## mingw-w64-qt6-quick3d-6.8.1-1.src.tar.zst

=== tools/shadergen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from shadergen.pro.

#####################################################################
## shadergen Tool:
#####################################################################

qt_get_tool_target_name(target_name shadergen)
qt_internal_add_tool(${target_name}
    TOOLS_TARGET Quick3D # special case
    SOURCES
        genshaders.cpp genshaders.h
        main.cpp
        parser.cpp parser.h
    LIBRARIES
        Qt::Gui
        Qt::GuiPrivate
        Qt::Qml
        Qt::QmlPrivate
        Qt::Quick3DPrivate
        Qt::Quick3DRuntimeRender
        Qt::Quick3DRuntimeRenderPrivate
        Qt::ShaderToolsPrivate
)
qt_internal_return_unless_building_tools()

=== examples/quick3d/volumeraycaster/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(volumeraycaster LANGUAGES CXX)
find_package(OpenMP)

set(CMAKE_AUTOMOC ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick Quick3D)

qt_add_executable(volumeraycaster
    main.cpp
    volumetexturedata.cpp
    volumetexturedata.h
    lineboxgeometry.cpp
    lineboxgeometry.h
)

set_target_properties(volumeraycaster PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(volumeraycaster PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Quick3D
)

if(OpenMP_CXX_FOUND AND NOT ANDROID)
    target_link_libraries(volumeraycaster PUBLIC
        OpenMP::OpenMP_CXX
    )
endif()

qt_add_qml_module(volumeraycaster
    URI VolumetricExample
    VERSION 1.0
    QML_FILES
        Main.qml
        ArcballController.qml
        OriginGizmo.qml
        Spinner.qml
    RESOURCES
        images/circle.png
        images/colormap-coolwarm.png
        images/colormap-gist_rainbow.png
        images/colormap-gnuplot.png
        images/colormap-plasma.png
        images/colormap-rainbow.png
        images/colormap-viridis.png
        alpha_blending.frag
        alpha_blending.vert
        SpacingMap.mjs
    RESOURCE_PREFIX "/qt/qml"
    IMPORTS
        QtQuick3D
)

install(TARGETS volumeraycaster
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET volumeraycaster
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

=== src/3rdparty/embree/CMakeLists.txt ===
qt_internal_add_3rdparty_library(BundledEmbree
    STATIC
    INSTALL
    EXCEPTIONS
)

qt_internal_extend_target(BundledEmbree
    SOURCES
        common/sys/sysinfo.cpp
        common/sys/alloc.cpp
        common/sys/filename.cpp
        common/sys/library.cpp
        common/sys/thread.cpp
        common/sys/string.cpp
        common/sys/regression.cpp
        common/sys/mutex.cpp
        common/sys/condition.cpp
        common/sys/barrier.cpp
        common/math/constants.cpp
        common/simd/sse.cpp
        common/lexers/stringstream.cpp
        common/lexers/tokenstream.cpp
        common/tasking/taskschedulerinternal.cpp
        kernels/common/device.cpp
        kernels/common/stat.cpp
        kernels/common/acceln.cpp
        kernels/common/accelset.cpp
        kernels/common/state.cpp
        kernels/common/rtcore.cpp
        kernels/common/rtcore_builder.cpp
        kernels/common/scene.cpp
        kernels/common/alloc.cpp
        kernels/common/geometry.cpp
        kernels/common/scene_triangle_mesh.cpp
        kernels/geometry/primitive4.cpp
        kernels/builders/primrefgen.cpp
        kernels/bvh/bvh.cpp
        kernels/bvh/bvh_statistics.cpp
        kernels/bvh/bvh4_factory.cpp
        kernels/bvh/bvh8_factory.cpp
        kernels/bvh/bvh_collider.cpp
        kernels/bvh/bvh_rotate.cpp
        kernels/bvh/bvh_refit.cpp
        kernels/bvh/bvh_builder.cpp
        kernels/bvh/bvh_builder_morton.cpp
        kernels/bvh/bvh_builder_sah.cpp
        kernels/bvh/bvh_builder_sah_spatial.cpp
        kernels/bvh/bvh_builder_sah_mb.cpp
        kernels/bvh/bvh_builder_twolevel.cpp
        kernels/bvh/bvh_intersector1_bvh4.cpp
)

qt_disable_warnings(BundledEmbree)
qt_set_symbol_visibility_hidden(BundledEmbree)

if (WIN32)
    qt_disable_unicode_defines(BundledEmbree)
endif()

if (IOS)
    qt_internal_extend_target(BundledEmbree COMPILE_OPTIONS -fembed-bitcode)
endif()

# Use SSE2 only, ignore AVX/SSE4.2 for now
qt_internal_extend_target(BundledEmbree DEFINES
    EMBREE_TARGET_SSE2
    __SSE2__
    __SSE__
    EMBREE_LOWEST_ISA
    TASKING_INTERNAL
    NDEBUG
)

=== tests/auto/quick3d/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from quick3d.pro.

add_subdirectory(qquick3dperspectivecamera)
add_subdirectory(qquick3dorthographiccamera)
add_subdirectory(qquick3dfrustumcamera)
add_subdirectory(qquick3dcustomcamera)
add_subdirectory(qquick3dtexture)
add_subdirectory(qquick3dtexturedata)
add_subdirectory(qquick3dmaterials)
add_subdirectory(qquick3ddirectionallight)
add_subdirectory(qquick3dpointlight)
add_subdirectory(qquick3dspotlight)
add_subdirectory(qquick3dnode)
add_subdirectory(qquick3dmodel)
add_subdirectory(qquick3dgeometry)
add_subdirectory(qquick3dresourceloader)
add_subdirectory(qquick3dreflectionprobe)

=== tests/auto/utils/shadercollection/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from shadercollection.pro.

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qquick3dshadercollection LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

if(NOT TARGET Qt::ShaderTools)
    return()
endif()

#####################################################################
## shadercollection Test:
#####################################################################

qt_internal_add_test(tst_qquick3dshadercollection
    SOURCES
        tst_shadercollection.cpp
    LIBRARIES
        Qt::Gui
        Qt::GuiPrivate
        Qt::Quick3DUtilsPrivate
        Qt::ShaderToolsPrivate
)

#### Keys ignored in scope 1:.:.:shadercollection.pro:<TRUE>:
# TEMPLATE = "app"
# _REQUIREMENTS = "qtHaveModule(shadertools)"

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-quick3d
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.8.1
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt module and API for defining 3D content in Qt Quick (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtquick3d.git"
msys2_references=(
  'archlinux: qt6-quick3d'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:GPL-3.0-only WITH Qt-GPL-exception-1.0 AND LGPL-3.0-only AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-assimp"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch
        002-fix-bezier-curve.patch
        003-fix-pointi.patch)
sha256sums=('3f3d345e6c95fcd40ab37e6a37cd31811e5d239dea8e142e632d4ea41bf20ce7'
            '211bb1f042bf9c0ddedb15b0e3d62b94e3b247dc96294fd92f4d8035784f1c7d'
            '774abd51e93fbcd9b4db4cd97a0200b546eccc0dc8ca9014c1a05a7c244e6bb8'
            'ce6302aee7306d5bbffb4c5887b102e542bf08068bed014ab4a91f1245cebed9')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch

  # https://bugreports.qt.io/browse/QTBUG-131962
  # https://github.com/RenderKit/embree/commit/cda4cf1919bb2a748e78915fbd6e421a1056638d
  apply_patch_with_msg \
    002-fix-bezier-curve.patch \
    003-fix-pointi.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-quick3d() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-quicktimeline"
              "${MINGW_PACKAGE_PREFIX}-assimp")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-quick3d-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
